## krb5 1.19.2

=== debian/changelog ===
krb5 (1.19.2-2ubuntu0.7) jammy-security; urgency=medium

  * SECURITY UPDATE: Use of weak cryptographic hash.
    - debian/patches/CVE-2025-3576.patch: Add allow_des3 and allow_rc4 options.
      Disallow usage of des3 and rc4 unless allowed in the config. Replace
      warn_des3 with warn_deprecated in ./src/lib/krb5/krb/get_in_tkt.c. Add
      allow_des3 and allow_rc4 boolean in ./src/include/k5-int.h. Prevent usage
      of deprecated enctypes in ./src/kdc/kdc_util.c.
    - debian/patches/CVE-2025-3576-post1.patch: Add enctype comparison with
      ENCTYPE_AES256_CTS_HMAC_SHA1_96 in ./src/kdc/kdc_util.c.
    - CVE-2025-3576

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 15 May 2025 12:06:20 +0200

krb5 (1.19.2-2ubuntu0.6) jammy-security; urgency=medium

  * SECURITY UPDATE: denial of service via two memory leaks
    - debian/patches/CVE-2024-26458.patch: fix two unlikely memory leaks in
      src/lib/gssapi/krb5/k5sealv3.c, src/lib/rpc/pmap_rmt.c.
    - CVE-2024-26458
    - CVE-2024-26461
  * SECURITY UPDATE: kadmind DoS via iprop log file
    - debian/patches/CVE-2025-24528.patch: prevent overflow when
      calculating ulog block size in src/lib/kdb/kdb_log.c.
    - CVE-2025-24528

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 25 Feb 2025 12:26:06 -0500

krb5 (1.19.2-2ubuntu0.5) jammy-security; urgency=medium

  * SECURITY UPDATE: Use of MD5-based message authentication over plaintext
    communications could lead to forgery attacks.
    - debian/patches/CVE-2024-3596.patch: Secure Response Authenticator
      by adding support for the Message-Authenticator attribute in non-EAP
      authentication methods.
    - CVE-2024-3596
  * Update libk5crypto3 symbols: add k5_hmac_md5 symbol.

 -- Nicolas Campuzano Jimenez <nicolas.campuzano@canonical.com>  Mon, 27 Jan 2025 19:37:24 -0500

krb5 (1.19.2-2ubuntu0.4) jammy-security; urgency=medium

  * SECURITY UPDATE: Invalid token requests
    - debian/patches/CVE-2024-37370.patch: Fix vulnerabilities in GSS
    message token handling
    - CVE-2024-37370
    - CVE-2024-37371

 -- Bruce Cable <bruce.cable@canonical.com>  Mon, 15 Jul 2024 13:46:10 +1000

krb5 (1.19.2-2ubuntu0.3) jammy-security; urgency=medium

  * SECURITY UPDATE: freeing of uninitialized memory
    - debian/patches/CVE-2023-36054.patch: ensure array count consistency in
      kadm5 RPC.
    - CVE-2023-36054

 -- Camila Camargo de Matos <camila.camargodematos@canonical.com>  Tue, 24 Oct 2023 13:59:06 -0300

krb5 (1.19.2-2ubuntu0.2) jammy; urgency=medium

  * d/kdc.conf: Do not specify master key type to avoid weak crypto for
    new realms. Existing realms will not be changed. (LP: #1981697)

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 06 Apr 2023 19:21:06 -0300

krb5 (1.19.2-2ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-42898.patch: add buffer length checks in
      krb5_pac_parse() in src/lib/krb5/krb/pac.c and a test case for
      invalid buffers in src/lib/krb5/krb/t_pac.c.
    - CVE-2022-42898

 -- Rodrigo Figueiredo Zaiden <rodrigo.zaiden@canonical.com>  Fri, 20 Jan 2023 08:34:37 -0300

krb5 (1.19.2-2) unstable; urgency=medium

  * Standards version 4.6.0; no change
  * kpropd: run after network.target, Closes: #948820
  * krb5-kdc: Remove /var from PidFile, Closes: #982009

 -- Sam Hartman <hartmans@debian.org>  Mon, 21 Feb 2022 13:05:20 -0700

krb5 (1.19.2-1) experimental; urgency=medium

  * New Upstream version
  * Include patch to work with OpenSSL 3.0, Closes: #995152
  * Depend on tex-gyre, Closes: #997407
    
 -- Sam Hartman <hartmans@debian.org>  Wed, 27 Oct 2021 14:04:42 -0600

krb5 (1.18.3-7) unstable; urgency=medium

  * Fix KDC null dereference crash on FAST request with no server field,
    CVE-2021-37750, Closes: #992607
  * Fix memory leak in krb5_gss_inquire_cred, Closes: #991140
  * Add javascript libraries for docs, thanks Andreas Beckmann, Closes: #988743
  * Drop build-dependency on libncurses5-dev which hasn't been needed
    since krb5-appl was removed, Closes: #981161

 -- Sam Hartman <hartmans@debian.org>  Fri, 27 Aug 2021 08:13:47 -0600

=== debian/control ===
Source: krb5
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13), byacc | bison,
 comerr-dev, docbook-to-man,
 libkeyutils-dev [linux-any], libldap2-dev <!stage1>, libsasl2-dev <!stage1>,
 libssl-dev,  ss-dev,
 libverto-dev (>= 0.2.4), pkg-config
Build-Depends-Indep: python3, python3-cheetah, python3-lxml, python3-sphinx, doxygen, doxygen-latex, tex-gyre
Standards-Version: 4.6.0
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
Homepage: http://web.mit.edu/kerberos/
VCS-Git: https://salsa.debian.org/debian/krb5
VCS-Browser: https://salsa.debian.org/debian/krb5

Package: krb5-user
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
  krb5-config
Multi-Arch: foreign
Conflicts: heimdal-clients
Suggests: krb5-k5tls
Description: basic programs to authenticate using MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the basic programs to authenticate to MIT Kerberos,
 change passwords, and talk to the admin server (to create and delete
 principals, list principals, etc.).

Package: krb5-kdc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
 libkadm5srv-mit12,
 krb5-config, krb5-user, lsb-base (>= 3.0-6), libverto-libev1 | libverto-libevent1,
 libkdb5-10 (>= 1.13.1+dfsg-1)
Pre-Depends: ${misc:Pre-Depends}
Suggests: krb5-kpropd, krb5-admin-server,
 krb5-kdc-ldap (= ${binary:Version})
Multi-Arch: foreign
Description: MIT Kerberos key server (KDC)
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the Kerberos key server (KDC).  The KDC manages all
 authentication credentials for a Kerberos realm, holds the master keys
 for the realm, and responds to authentication requests.  This package
 should be installed on both master and slave KDCs.

Package: krb5-kdc-ldap
Architecture: any
Build-Profiles: <!stage1>
Depends: ${misc:Depends}, ${shlibs:Depends}, krb5-kdc (= ${binary:Version})
Description: MIT Kerberos key server (KDC) LDAP plugin
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the LDAP plugin for the Kerberos key server (KDC)
 and supporting utilities.  This plugin allows the KDC data to be stored
 in an LDAP server rather than the default local database.  It should be
 installed on both master and slave KDCs that use LDAP as a storage
 backend.

Package: krb5-admin-server
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
 krb5-kdc (>= 1.10+dfsg~), lsb-base (>= 3.0-6)
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: foreign
Description: MIT Kerberos master server (kadmind)
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the Kerberos master server (kadmind), which handles
 account creations and deletions, password changes, and other
 administrative commands via the Kerberos admin protocol.  It also
 contains the command used by the master KDC to propagate its database to
 slave KDCs.  This package is generally only used on the master KDC for a
 Kerberos realm.

Package: krb5-kpropd
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends},
 krb5-kdc (= ${binary:Version}),
 lsb-base
Replaces: krb5-kdc (<< 1.15.1-3~)
Suggests: openbsd-inetd | inet-superserver
Description: MIT Kerberos key server (Slave KDC Support)
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the Kerberos slave KDC update server (kpropd). The
 kpropd command runs on the slave KDC server. It listens for update requests
 made by the kprop program, and periodically requests incremental updates from
 the master KDC. This package should be installed on slave KDCs.

Package: krb5-multidev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version}),
 libk5crypto3 (= ${binary:Version}), libgssapi-krb5-2 (= ${binary:Version}),
 libgssrpc4 (= ${binary:Version}),
 libkadm5srv-mit12  (= ${binary:Version}),
 libkadm5clnt-mit12 (= ${binary:Version}),
 comerr-dev
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Suggests: krb5-doc
Description: development files for MIT Kerberos without Heimdal conflict
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 Most users wishing to build applications against MIT Kerberos should
 install libkrb5-dev.  However, that package conflicts with heimdal-dev.
 This package installs libraries and headers in /usr/include/mit-krb5 and
 /usr/lib/mit-krb5 and can be installed along side heimdal-multidev, which
 provides the same facilities for Heimdal.

Package: libkrb5-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, krb5-multidev (= ${binary:Version})
Replaces: krb5-multidev (<< 1.8+dfsg~alpha1-3)
Conflicts: heimdal-dev
Multi-Arch: same
Suggests: krb5-doc
Description: headers and development libraries for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the symlinks, headers, and development libraries
 needed to compile and link programs that use the Kerberos libraries.

Package: libkrb5-dbg
Architecture: any
Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version})
 | libk5crypto3 (= ${binary:Version})
 | libkrb5support0 (= ${binary:Version})
Section: debug
Multi-Arch: same
Description: debugging files for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the debugging information for the MIT Kerberos
 libraries.  Install this package if you need to trace problems inside the
 MIT Kerberos libraries with a debugger.

Package: krb5-pkinit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version})
Breaks: krb5-kdc (<< 1.14+dfsg)
Suggests: opensc
Multi-Arch: same
Description: PKINIT plugin for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains a plugin for the PKINIT protocol, which allows
 Kerberos tickets to be obtained using public-key credentials such as
 X.509 certificates or a smart card.  This plugin can be used by the
 client libraries and the KDC.

Package: krb5-otp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrad0 (= ${binary:Version}),
 libkrb5-3 (>= 1.12~alpha1+dfsg-1~)
Multi-Arch: same
Description: OTP plugin for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains a plugin for the OTP preauthentication method
 (RFC 6560), which allows Kerberos tickets to be obtained using
 One-Time Password authentication.  This plugin is for use on the KDC; the
 client support is built in to libkrb5.

Package: krb5-k5tls
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (>= 1.13~alpha1+dfsg~)
Multi-Arch: same
Description: TLS plugin for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains a plugin for the TLS functionality used by optional
 functionality in MIT Kerberos.  The only current consumer is client support
 for the MS-KKDCP protocol, which tunnels Kerberos protocol traffic through
 an HTTPS proxy.

Package: krb5-doc
Architecture: all
Multi-Arch: foreign
Conflicts: heimdal-docs
Section: doc
Depends: ${misc:Depends}
Recommends: libjs-sphinxdoc, libjs-jquery, libjs-underscore
Description: documentation for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the installation, administrator, and user reference
 manuals for MIT Kerberos and the man pages for the MIT Kerberos
 configuration files.

Package: libkrb5-3
Section: libs
Breaks:  sssd (<= 1.2.1-4.3), libsmbclient (<= 2:3.6.1-2), libapache2-mod-auth-kerb (<= 5.4-2.4)
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 libkrb5support0 (= ${binary:Version})
Suggests: krb5-doc, krb5-user
Recommends: krb5-locales
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIT Kerberos runtime libraries
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .

=== debian/rules ===
#!/usr/bin/make -f
# Based on sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

SHELL=/bin/bash
export SHELL


export DEB_HOST_MULTIARCH


# The flags to pass to dh_install specifying the upstream files to exclude.
# We use --fail-missing to be sure we catch any new upstream files, so be
# sure to update this list if upstream adds any more files we don't want.
EXCLUDE = -Xtmac.doc -Xexamples/krb5 -Xgnats/mit -Xkrb5-send-pr \
	-Xsserver -Xsim_server -Xuuserver \
	-Xsclient -Xsim_client -Xuuclient -Xpreauth/test.so

LIB_PACKAGES = libkrb5-3 libgssapi-krb5-2 libkadm5clnt-mit12 libkadm5srv-mit12 libkdb5-10 libgssrpc4  \
	libkrb5support0  libk5crypto3 libkrad0

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
KRB5_SKIP_LDAP=        1
endif

ifeq (,$(KRB5_SKIP_LDAP))
CONFIGURE_LDAP=        --with-ldap
else
CONFIGURE_LDAP=        --without-ldap
endif
DH_BUILD_OPTS= --sourcedir=src --builddir=build

build: build-arch build-indep


override_dh_auto_configure:
	dh_auto_configure $(DH_BUILD_OPTS) -- --with-system-et --with-system-ss --disable-rpath  \
		--enable-shared $(CONFIGURE_LDAP) --without-tcl \
	--with-system-verto \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--sysconfdir=/etc  \
		--localstatedir=/etc

override_dh_auto_build:
	dh_auto_build $(DH_BUILD_OPTS)

# Build the documentation in a separate directory, since otherwise we'll
# overwrite the info pages provided upstream and then debian/rules clean won't
build-indep: build-indep-stamp
# build-indep should not need to depend on build-arch, but currently it does at least to populate build/doc
# Add the dependency until we get a chance to make it work properly
build-indep-stamp:  build-arch
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	cd build/doc && make PYTHON=python3 substhtml substpdf
	ln -sf /usr/share/javascript/jquery/jquery.js build/doc/html_subst/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js build/doc/html_subst/_static/underscore.js
	ln -sf /usr/share/javascript/sphinxdoc/1.0/doctools.js build/doc/html_subst/_static/doctools.js
	ln -sf /usr/share/javascript/sphinxdoc/1.0/searchtools.js build/doc/html_subst/_static/searchtools.js
	touch build-indep-stamp
endif

clean:
	dh_testdir
	-rm -rf  build doc/tools/*.pyc doc/version.py
	dh_clean build-indep-stamp


override_dh_auto_install:

	dh_auto_install $(DH_BUILD_OPTS)
	install -d $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5 $(CURDIR)/debian/tmp/etc/insserv/overrides
ifeq (,$(KRB5_SKIP_LDAP))
	install -m644 debian/krb5-kdc-ldap.insserv-override debian/tmp/etc/insserv/overrides/krb5-kdc
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libkdb_ldap* \
	    $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5/
	rm -f $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5/libkdb_ldap*.so
else
	rm -f $(CURDIR)/debian/tmp/usr/share/man/man8/kdb5_ldap_util.8
endif
	mv $(CURDIR)/debian/tmp/usr/bin/krb5-config \
	    $(CURDIR)/debian/tmp/usr/bin/krb5-config.mit
	mv $(CURDIR)/debian/tmp/usr/share/man/man1/krb5-config.1 \
	    $(CURDIR)/debian/tmp/usr/share/man/man1/krb5-config.mit.1

	install -d $(CURDIR)/debian/tmp/usr/share/aclocal
	install -m644 src/util/ac_check_krb5.m4 \
		$(CURDIR)/debian/tmp/usr/share/aclocal


override_dh_install-arch:
	dh_install   $(EXCLUDE) --sourcedir=.
	set -e ; find debian/krb5-multidev/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5 -type l -name \*.so -print |\
		while read linkname; do \
		ln -s -f ../`readlink $$linkname` \
		$$linkname; \
	done
		rm debian/krb5-multidev/usr/include/mit-krb5/krad.h debian/krb5-multidev/usr/lib/*/mit-krb5/libkrad.so
		for dir in include lib/$(DEB_HOST_MULTIARCH) lib/$(DEB_HOST_MULTIARCH)/pkgconfig; do \
		(cd debian/krb5-multidev/usr/$$dir/mit-krb5 && \
		find . -type d -print ) | (cd debian/libkrb5-dev/usr/$$dir && \
		xargs mkdir -p); \
		(cd debian/krb5-multidev/usr/$$dir/mit-krb5 && find . \( -type f -o -type l \) -print ) | \
		(cd debian/libkrb5-dev/usr/$$dir && xargs -I+ ln -s /usr/$$dir/mit-krb5/+ +) ; \
		done
	# however we will handle libkadm5{srv,clnt.so} in dh_link
# because they actually point to the current level not one level up
	rm -f debian/krb5-multidev/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5/libkadm5{clnt,srv}.so


	docbook-to-man debian/krb5_newrealm.sgml \
		> debian/krb5-admin-server/usr/share/man/man8/krb5_newrealm.8
	install -o root -g root -m 755 debian/krb5_newrealm \
		debian/krb5-admin-server/usr/sbin
	install -o root -g root -m 644 debian/kdc.conf \
		debian/krb5-kdc/usr/share/krb5-kdc/kdc.conf.template
	ln -s /usr/share/krb5-kdc/kdc.conf.template \
		debian/krb5-kdc/usr/share/doc/krb5-kdc/examples/kdc.conf

override_dh_installinit:
	# We don't need to override systemd because the systemd behavior is reasonable, and we're just trying to work around issues with error handling in init scripts
	DH_OPTIONS= dh_installinit -pkrb5-kdc --error-handler=init_error -- defaults 18 18
	DH_OPTIONS= dh_installinit -pkrb5-kpropd -- defaults 18 18
		DH_OPTIONS= dh_installinit -pkrb5-admin-server -- defaults 18 18

override_dh_strip:
	set -e ; for pkg in $(LIB_PACKAGES) ; do \
		DH_OPTIONS="" dh_strip -p$$pkg --dbg-package=libkrb5-dbg; \
	done
	dh_strip

override_dh_makeshlibs:
	dh_makeshlibs -Xkrb5/plugins --  -c4

override_dh_fixperms-arch:
	dh_fixperms
	chmod u+s debian/krb5-user/usr/bin/ksu
	chmod 700 debian/krb5-kdc/var/lib/krb5kdc
	chmod 700 debian/krb5-kdc/etc/krb5kdc

override_dh_auto_test: 

%:
	dh $@ 


#.PHONY: build clean configure binary-indep binary-arch binary install

## krb5 1.20

=== debian/changelog ===
krb5 (1.20-1) unstable; urgency=medium

  * New Upstream Version
  * Do not specify master key type to avoid weak crypto, Closes: #1009927

 -- Sam Hartman <hartmans@debian.org>  Fri, 22 Jul 2022 16:32:38 -0600

krb5 (1.20~beta1-1) experimental; urgency=medium

  * New Upstream version

 -- Sam Hartman <hartmans@debian.org>  Thu, 07 Apr 2022 11:57:27 -0600

=== debian/rules ===
--- 
+++ 
@@ -43,7 +43,6 @@
 	dh_auto_configure $(DH_BUILD_OPTS) -- --with-system-et --with-system-ss --disable-rpath  \
 		--enable-shared $(CONFIGURE_LDAP) --without-tcl \
 	--with-system-verto \
-		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--sysconfdir=/etc  \
 		--localstatedir=/etc

## krb5 1.20.1

=== debian/changelog ===
krb5 (1.20.1-6ubuntu2.6) noble-security; urgency=medium

  * SECURITY UPDATE: Use of weak cryptographic hash.
    - debian/patches/CVE-2025-3576.patch: Add allow_des3 and allow_rc4 options.
      Disallow usage of des3 and rc4 unless allowed in the config. Replace
      warn_des3 with warn_deprecated in ./src/lib/krb5/krb/get_in_tkt.c. Add
      allow_des3 and allow_rc4 boolean in ./src/include/k5-int.h. Prevent usage
      of deprecated enctypes in ./src/kdc/kdc_util.c.
    - debian/patches/CVE-2025-3576-post1.patch: Add enctype comparison with
      ENCTYPE_AES256_CTS_HMAC_SHA1_96 in ./src/kdc/kdc_util.c.
    - CVE-2025-3576

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 15 May 2025 10:09:20 +0200

krb5 (1.20.1-6ubuntu2.5) noble-security; urgency=medium

  * SECURITY UPDATE: denial of service via two memory leaks
    - debian/patches/CVE-2024-26458.patch: fix two unlikely memory leaks in
      src/lib/gssapi/krb5/k5sealv3.c, src/lib/rpc/pmap_rmt.c.
    - CVE-2024-26458
    - CVE-2024-26461
  * SECURITY UPDATE: denial of service via memory leak
    - debian/patches/CVE-2024-26462.patch: fix leak in KDC NDR encoding in
      src/kdc/ndr.c.
    - CVE-2024-26462
  * SECURITY UPDATE: kadmind DoS via iprop log file
    - debian/patches/CVE-2025-24528.patch: prevent overflow when
      calculating ulog block size in src/lib/kdb/kdb_log.c.
    - CVE-2025-24528

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 25 Feb 2025 10:30:21 -0500

krb5 (1.20.1-6ubuntu2.4) noble-security; urgency=medium

  * No-change rebuild to solve a build issue on armhf.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 13 Feb 2025 07:23:16 -0500

krb5 (1.20.1-6ubuntu2.3) noble-security; urgency=medium

  * SECURITY UPDATE: Use of MD5-based message authentication over plaintext
    communications could lead to forgery attacks.
    - debian/patches/CVE-2024-3596.patch: Secure Response Authenticator
      by adding support for the Message-Authenticator attribute in non-EAP
      authentication methods.
    - CVE-2024-3596 
  * Update libk5crypto3 symbols: add k5_hmac_md5 symbol.

 -- Nicolas Campuzano Jimenez <nicolas.campuzano@canonical.com>  Tue, 28 Jan 2025 00:57:01 -0500

krb5 (1.20.1-6ubuntu2.2) noble; urgency=medium

  * SRU: LP: #2083480: No-change rebuild to disable frame pointers on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 14:40:50 +0200

krb5 (1.20.1-6ubuntu2.1) noble-security; urgency=medium

  * SECURITY UPDATE: Invalid token requests
    - debian/patches/CVE-2024-37370.patch: Fix vulnerabilities in GSS
    message token handling
    - CVE-2024-37370
    - CVE-2024-37371

 -- Bruce Cable <bruce.cable@canonical.com>  Mon, 15 Jul 2024 13:27:45 +1000

krb5 (1.20.1-6ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:42:10 +0000

krb5 (1.20.1-6ubuntu1) noble; urgency=medium

  * Fix tests with Python 3.12.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 24 Mar 2024 12:51:41 +0100

krb5 (1.20.1-6) unstable; urgency=medium

  * Fix up libverto1*->libverto1*t64, Closes: #1065702

 -- Sam Hartman <hartmans@debian.org>  Sun, 10 Mar 2024 19:36:33 -0600

krb5 (1.20.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064164

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 15:25:37 +0000

krb5 (1.20.1-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Annotate test dependencies <!nocheck>. (Closes: #1054461)

  [ Sam Hartman ]
  * Fix keyutils to be linux-any

 -- Helmut Grohne <helmut@subdivi.de>  Tue, 24 Oct 2023 07:17:27 +0200

krb5 (1.20.1-4) unstable; urgency=low

  [ Steve Langasek ]
  * libkrb5support0: require strict binary dependency to deal with glibc 2.38, Closes: #1043184

  [Jelmer Vernooij]
  * krb5-user: Use alternatives for kinit, klist, kswitch, ksu, kpasswd,
    kdestroy, kadmin and ktutil. This allows installation
    together with heimdal-clients. Closes: #213316, #751203

  [ Sam Hartman ]
  * Enable build-time tests, Thanks Andreas Hasenack, Closes: #1017763
  * Work around doxygen change that breaks doc build, Thanks Greg
    Hudson, Closes: #1051523

 -- Sam Hartman <hartmans@debian.org>  Mon, 11 Sep 2023 11:06:57 -0600

krb5 (1.20.1-3) unstable; urgency=high

  * Fixes CVE-2023-36054: a  remote authenticated attacker can cause
    kadmind to free an uninitialized pointer.  Upstream believes remote
    code execusion is unlikely, Closes: #1043431 

 -- Sam Hartman <hartmans@debian.org>  Mon, 14 Aug 2023 14:06:53 -0600

krb5 (1.20.1-2) unstable; urgency=medium

  * Tighten dependencies on libkrb5support0.  This means that the entire
    upgrade from bullseye to bookworm needs to be lockstep, but it appears
    that's what is required, Closes: #1036055
  

 -- Sam Hartman <hartmans@debian.org>  Mon, 15 May 2023 17:44:41 -0600

krb5 (1.20.1-1) unstable; urgency=high

  [ Bastian Germann ]
  * Sync debian/copyright with NOTICE from upstream

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Strip unusual field spacing from debian/control.
  * Use secure URI in Homepage field.
  * Merge upstream signing key files.
  * Update renamed lintian tag names in lintian overrides.
  * Update standards version to 4.6.1, no changes needed.
  * Remove field Section on binary package krb5-gss-samples that
    duplicates source.
  * Fix field name cases in debian/control (VCS-Browser => Vcs-Browser,
    VCS-Git => Vcs-Git).

  [ Sam Hartman ]
  * New upstream release
    - Integer overflows in PAC parsing; potentially critical for 32-bit
    KDCs or when cross-realm acts maliciously; DOS in other conditions;
    CVE-2022-42898, Closes: #1024267
  * Tighten version dependencies around crypto library, Closes: 1020424
  * krb5-user reccomends rather than Depends on krb5-config.  This avoids
    a hard dependency on bind9-host, but also supports cases where


=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	-Xsserver -Xsim_server -Xuuserver \
 	-Xsclient -Xsim_client -Xuuclient -Xpreauth/test.so
 
-LIB_PACKAGES = libkrb5-3 libgssapi-krb5-2 libkadm5clnt-mit12 libkadm5srv-mit12 libkdb5-10 libgssrpc4  \
+LIB_PACKAGES = libkrb5-3 libgssapi-krb5-2 libkadm5clnt-mit12 libkadm5srv-mit12 libkdb5-10t64 libgssrpc4t64  \
 	libkrb5support0  libk5crypto3 libkrad0
 
 ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
@@ -120,6 +120,10 @@
 		debian/krb5-kdc/usr/share/krb5-kdc/kdc.conf.template
 	ln -s /usr/share/krb5-kdc/kdc.conf.template \
 		debian/krb5-kdc/usr/share/doc/krb5-kdc/examples/kdc.conf
+	for I in kdestroy kinit klist kpasswd ksu kadmin ktutil kswitch; do { \
+		mv debian/krb5-user/usr/bin/$$I debian/krb5-user/usr/bin/$$I.mit; \
+		mv debian/krb5-user/usr/share/man/man1/$$I.1 debian/krb5-user/usr/share/man/man1/$$I.mit.1; \
+	} done
 
 override_dh_installinit:
 	# We don't need to override systemd because the systemd behavior is reasonable, and we're just trying to work around issues with error handling in init scripts
@@ -138,14 +142,15 @@
 
 override_dh_fixperms-arch:
 	dh_fixperms
-	chmod u+s debian/krb5-user/usr/bin/ksu
+	chmod u+s debian/krb5-user/usr/bin/ksu.mit
 	chmod 700 debian/krb5-kdc/var/lib/krb5kdc
 	chmod 700 debian/krb5-kdc/etc/krb5kdc
 
-override_dh_auto_test: 
+override_dh_auto_test:
+	dh_auto_test $(DH_BUILD_OPTS) --no-parallel
 
 %:
-	dh $@ 
+	dh $@
 
 
 #.PHONY: build clean configure binary-indep binary-arch binary install

=== debian/tests/control ===
Tests: kinit
Depends: @
Restrictions: isolation-container, needs-root, allow-stderr

Tests: slapd-gssapi
Depends: ldap-utils, libsasl2-modules-gssapi-mit, slapd, @
Restrictions: isolation-container, needs-root, allow-stderr

## krb5 1.21.3

=== debian/changelog ===
krb5 (1.21.3-4ubuntu2) plucky; urgency=medium

  * SECURITY UPDATE: denial of service via two memory leaks
    - debian/patches/CVE-2024-26458.patch: fix two unlikely memory leaks in
      src/lib/gssapi/krb5/k5sealv3.c, src/lib/rpc/pmap_rmt.c.
    - CVE-2024-26458
    - CVE-2024-26461
  * SECURITY UPDATE: kadmind DoS via iprop log file
    - debian/patches/CVE-2025-24528.patch: prevent overflow when
      calculating ulog block size in src/lib/kdb/kdb_log.c.
    - CVE-2025-24528

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 25 Feb 2025 10:22:31 -0500

krb5 (1.21.3-4ubuntu1) plucky; urgency=medium

  * SECURITY UPDATE: Use of MD5-based message authentication over plaintext
    communications could lead to forgery attacks.
    - debian/patches/CVE-2024-3596.patch: Secure Response Authentication
      by adding support for the Message-Authenticator attribute in non-EAP
      authentication methods.
    - CVE-2024-3596
  * Update libk5crypto3 symbols: add k5_hmac_md5 symbol.

 -- Nicolas Campuzano Jimenez <nicolas.campuzano@canonical.com>  Tue, 04 Feb 2025 11:30:48 -0500

krb5 (1.21.3-4) unstable; urgency=medium

  [ Fabio Pedretti ]
  * fix bug closing syntax

  [ Sam Hartman ]
  * Do not set ownership in debian/rules so we can work without fakeroot,
  Thanks Guillem Jover for patch and for pointing out that setuid for ksu
  will still work, Closes: #1092384
  * Update standards-version to 4.7.0 (no change)
  * build-depend on pkgconf not pkg-config

 -- Sam Hartman <hartmans@debian.org>  Thu, 16 Jan 2025 11:26:01 -0700

krb5 (1.21.3-3) unstable; urgency=medium

  * Fix sysconfdir in call to configure, broken in previous upload, Closes: #1075813

 -- Sam Hartman <hartmans@debian.org>  Fri, 05 Jul 2024 11:25:26 -0600

krb5 (1.21.3-2) unstable; urgency=high

  * Enable lmdb database, Closes: #1075723
  * use libnss-myhostname to guarantee we have a hostname for builds, Closes: #1063648

 -- Sam Hartman <hartmans@debian.org>  Wed, 03 Jul 2024 13:47:10 -0600

krb5 (1.21.3-1) unstable; urgency=high

  * New Upstream version
    -     CVE-2024-37370: an unauthenticated attacker can modify the
    extra count in an RFC 4121 GSS token, causing the token to appear
    truncated.
    - CVE-2024-37371: an attacker can cause invalid memory reads by
    sending an invalid GSS token.
  * Drop doxygen work around patch: applied upstream
  * Fix Python 3.12 tests: replace ssl.wrap_socket, Closes: #1067610

 -- Sam Hartman <hartmans@debian.org>  Thu, 27 Jun 2024 11:54:54 -0600

krb5 (1.21.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Otto Kekäläinen ]
  * Run 'wrap-and-sort'
  * Drop obsolete dependency on package lsb-base
  * Make package Lintian clean
  * Enable Salsa-CI

  [ Chris Hofstaedtler ]
  *  Install systemd unit overrides into /usr. (DEP17 M2). Closes: #1072915

  [ Sam Hartman ]
  * New Upstream version 1.21.2, Closes: #1070848
  * Update symbols and breaks for internal APIs that were removed
  * Allow kpropd to bind even if only loopback is configured, Closes: #1072952
  * Skip keyring tests if keyring blocked by seccomp

 -- Sam Hartman <hartmans@debian.org>  Fri, 14 Jun 2024 16:39:28 -0600

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,47 @@
 Source: krb5
 Section: net
 Priority: optional
-Build-Depends: debhelper-compat (= 13), byacc | bison,
- comerr-dev, docbook-to-man,
- libkeyutils-dev [linux-any], libldap2-dev <!stage1>, libsasl2-dev <!stage1>,
- libssl-dev,  ss-dev,
- libverto-dev (>= 0.2.4), pkg-config
-Build-Depends-Indep: python3, python3-cheetah, python3-lxml, python3-sphinx, doxygen, doxygen-latex, tex-gyre
-Standards-Version: 4.6.0
+Build-Depends: byacc | bison,
+               comerr-dev,
+               debhelper-compat (= 13),
+               docbook-to-man,
+               dpkg-dev (>= 1.22.5),
+               libkeyutils-dev [linux-any],
+               libldap2-dev <!stage1>,
+               liblmdb-dev, 
+               libnss-myhostname, 
+               libsasl2-dev <!stage1>,
+               libssl-dev,
+               libverto-dev,
+               pkgconf,
+               ss-dev
+Build-Depends-Indep: doxygen,
+                     doxygen-latex,
+                     python3,
+                     python3-cheetah,
+                     python3-lxml,
+                     python3-sphinx,
+                     tex-gyre
+Build-Depends-Arch: dpkg-dev (>= 1.22.5),
+                    keyutils [linux-any] <!nocheck>,
+                    libcmocka-dev <!nocheck>,
+                    python3-kdcproxy <!nocheck>,
+                    python3-pyrad <!nocheck>
+Standards-Version: 4.7.0
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
 Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
-Homepage: http://web.mit.edu/kerberos/
-VCS-Git: https://salsa.debian.org/debian/krb5
-VCS-Browser: https://salsa.debian.org/debian/krb5
+Homepage: https://web.mit.edu/kerberos/
+Vcs-Git: https://salsa.debian.org/debian/krb5
+Vcs-Browser: https://salsa.debian.org/debian/krb5
 
 Package: krb5-user
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
-  krb5-config
-Multi-Arch: foreign
-Conflicts: heimdal-clients
+Depends: libkrb5-3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Recommends: krb5-config
+Multi-Arch: foreign
 Suggests: krb5-k5tls
+Conflicts: heimdal-clients (<< 1.6~rc2+dfsg-7)
 Description: basic programs to authenticate using MIT Kerberos
  Kerberos is a system for authenticating users and services on a network.
  Kerberos is a trusted third-party service.  That means that there is a
@@ -36,13 +56,16 @@
 
 Package: krb5-kdc
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
- libkadm5srv-mit12,
- krb5-config, krb5-user, lsb-base (>= 3.0-6), libverto-libev1 | libverto-libevent1,
- libkdb5-10 (>= 1.13.1+dfsg-1)
-Pre-Depends: ${misc:Pre-Depends}
-Suggests: krb5-kpropd, krb5-admin-server,
- krb5-kdc-ldap (= ${binary:Version})
+Depends: krb5-config,
+         krb5-user,
+         libkadm5srv-mit12,
+         libkdb5-10t64 (>= 1.13.1+dfsg-1),
+         libkrb5-3 (= ${binary:Version}),
+         libverto-libev1t64 | libverto-libevent1t64,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Suggests: krb5-admin-server, krb5-kdc-ldap (= ${binary:Version}), krb5-kpropd
 Multi-Arch: foreign
 Description: MIT Kerberos key server (KDC)
  Kerberos is a system for authenticating users and services on a network.
@@ -60,7 +83,7 @@
 Package: krb5-kdc-ldap
 Architecture: any
 Build-Profiles: <!stage1>
-Depends: ${misc:Depends}, ${shlibs:Depends}, krb5-kdc (= ${binary:Version})
+Depends: krb5-kdc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: MIT Kerberos key server (KDC) LDAP plugin
  Kerberos is a system for authenticating users and services on a network.
  Kerberos is a trusted third-party service.  That means that there is a
@@ -77,8 +100,10 @@
 
 Package: krb5-admin-server
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
- krb5-kdc (>= 1.10+dfsg~), lsb-base (>= 3.0-6)
+Depends: krb5-kdc,
+         libkrb5-3 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: foreign
 Description: MIT Kerberos master server (kadmind)
@@ -100,10 +125,9 @@
 Architecture: any
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends},
- krb5-kdc (= ${binary:Version}),
- lsb-base
-Replaces: krb5-kdc (<< 1.15.1-3~)
+Depends: krb5-kdc (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: openbsd-inetd | inet-superserver
 Description: MIT Kerberos key server (Slave KDC Support)
  Kerberos is a system for authenticating users and services on a network.
@@ -121,12 +145,14 @@
 Package: krb5-multidev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version}),
- libk5crypto3 (= ${binary:Version}), libgssapi-krb5-2 (= ${binary:Version}),
- libgssrpc4 (= ${binary:Version}),
- libkadm5srv-mit12  (= ${binary:Version}),
- libkadm5clnt-mit12 (= ${binary:Version}),
- comerr-dev
+Depends: comerr-dev,
+         libgssapi-krb5-2 (= ${binary:Version}),
+         libgssrpc4t64 (= ${binary:Version}),
+         libk5crypto3 (= ${binary:Version}),
+         libkadm5clnt-mit12 (= ${binary:Version}),
+         libkadm5srv-mit12  (= ${binary:Version}),
+         libkrb5-3 (= ${binary:Version}),
+         ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Suggests: krb5-doc
@@ -148,8 +174,7 @@
 Section: libdevel
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, krb5-multidev (= ${binary:Version})
-Replaces: krb5-multidev (<< 1.8+dfsg~alpha1-3)
+Depends: krb5-multidev (= ${binary:Version}), ${misc:Depends}
 Conflicts: heimdal-dev
 Multi-Arch: same
 Suggests: krb5-doc
@@ -166,9 +191,8 @@
 
 Package: libkrb5-dbg
 Architecture: any
-Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version})
- | libk5crypto3 (= ${binary:Version})
- | libkrb5support0 (= ${binary:Version})
+Depends: libkrb5-3 (= ${binary:Version}) | libk5crypto3 (= ${binary:Version}) | libkrb5support0 (= ${binary:Version}),
+         ${misc:Depends}
 Section: debug
 Multi-Arch: same
 Description: debugging files for MIT Kerberos
@@ -185,8 +209,7 @@
 
 Package: krb5-pkinit
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version})
-Breaks: krb5-kdc (<< 1.14+dfsg)
+Depends: libkrb5-3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Suggests: opensc
 Multi-Arch: same
 Description: PKINIT plugin for MIT Kerberos
@@ -204,8 +227,9 @@
 
 Package: krb5-otp
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrad0 (= ${binary:Version}),
- libkrb5-3 (>= 1.12~alpha1+dfsg-1~)
+Depends: libkrad0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Multi-Arch: same
 Description: OTP plugin for MIT Kerberos
  Kerberos is a system for authenticating users and services on a network.
@@ -222,7 +246,7 @@
 
 Package: krb5-k5tls
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (>= 1.13~alpha1+dfsg~)
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: TLS plugin for MIT Kerberos
  Kerberos is a system for authenticating users and services on a network.
@@ -243,7 +267,7 @@
 Conflicts: heimdal-docs
 Section: doc
 Depends: ${misc:Depends}
-Recommends: libjs-sphinxdoc, libjs-jquery, libjs-underscore
+Recommends: libjs-jquery, libjs-sphinxdoc, libjs-underscore
 Description: documentation for MIT Kerberos
  Kerberos is a system for authenticating users and services on a network.
  Kerberos is a trusted third-party service.  That means that there is a
@@ -258,19 +282,7 @@
 
 Package: libkrb5-3
 Section: libs
-Breaks:  sssd (<= 1.2.1-4.3), libsmbclient (<= 2:3.6.1-2), libapache2-mod-auth-kerb (<= 5.4-2.4)
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
- libkrb5support0 (= ${binary:Version})
-Suggests: krb5-doc, krb5-user
-Recommends: krb5-locales
-Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Description: MIT Kerberos runtime libraries
- Kerberos is a system for authenticating users and services on a network.
- Kerberos is a trusted third-party service.  That means that there is a
- third party (the Kerberos server) that is trusted by all the entities on
- the network (users and services, usually called "principals").
- .
- This is the MIT reference implementation of Kerberos V5.
- .
+Breaks: libapache2-mod-auth-kerb (<= 5.4-2.4)
+Architecture: any
+Depends: libkrb5support0 (= ${binary:Version}),
+         ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -38,11 +38,19 @@
 
 build: build-arch build-indep
 
+execute_before_dh_auto_build:
+	# It's fine for a test program not to get some of the hardening flags because
+	# it is never installed
+	@echo 'blhc: ignore-line-regexp: .* -o t_trval .*'
+	# It's not a problem that fortify flags are absent when preprosessor creates
+	# version identifier in docs
+	@echo 'blhc: ignore-line-regexp: .*doc/version.py'
 
 override_dh_auto_configure:
 	dh_auto_configure $(DH_BUILD_OPTS) -- --with-system-et --with-system-ss --disable-rpath  \
 		--enable-shared $(CONFIGURE_LDAP) --without-tcl \
 	--with-system-verto \
+	--with-lmdb \
 		--sysconfdir=/etc  \
 		--localstatedir=/etc
 
@@ -114,9 +122,9 @@
 
 	docbook-to-man debian/krb5_newrealm.sgml \
 		> debian/krb5-admin-server/usr/share/man/man8/krb5_newrealm.8
-	install -o root -g root -m 755 debian/krb5_newrealm \
+	install -m 755 debian/krb5_newrealm \
 		debian/krb5-admin-server/usr/sbin
-	install -o root -g root -m 644 debian/kdc.conf \
+	install -m 644 debian/kdc.conf \
 		debian/krb5-kdc/usr/share/krb5-kdc/kdc.conf.template
 	ln -s /usr/share/krb5-kdc/kdc.conf.template \
 		debian/krb5-kdc/usr/share/doc/krb5-kdc/examples/kdc.conf

## krb5 1.22.1

=== src/windows/installer/wix/Makefile ===

# Build language
LANG=1033

# Program macros
CANDLE=candle -nologo

LIGHT=light -nologo

CD=cd

RM=del

MAKE=nmake -nologo


# Targets

OUTPATH=.

OBJFILE=$(OUTPATH)\kfw.wixobj

MSIFILE=$(OUTPATH)\kfw.msi

WIXINCLUDES= \
	config.wxi \
	features.wxi \
	files.wxi \
	property.wxi \
	runtime.wxi \
	site-local.wxi \
	lang\strings_$(LANG).wxl \
	lang\ui_$(LANG).wxi \
	lang\config_$(LANG).wxi

CUSTOMDLL=custom\custom.dll

!if !defined(CPU) || "$(CPU)" == ""
CPU=$(PROCESSOR_ARCHITECTURE)
!endif # CPU

!if ( "$(CPU)" == "X86" ) || ( "$(CPU)" == "x86" ) || ( "$(CPU)" == "i386" )
WIXARCH = x86
!elseif ( "$(CPU)" == "AMD64" )
WIXARCH = x64
!else
!error "Architecture $(CPU) not supported by installer"
!endif

all: $(MSIFILE)

$(OBJFILE): kfw.wxs $(WIXINCLUDES)
	$(CANDLE) -arch $(WIXARCH) -out $@ kfw.wxs \
		"-dDate=%DATE%" \
		"-dTime=%TIME%" \
		-dBuildLang=$(LANG)

$(MSIFILE): $(OBJFILE) $(CUSTOMDLL)
	$(LIGHT) -out $@ $(OBJFILE) \
		-loc lang\strings_$(LANG).wxl -ext WixUtilExtension.dll

$(CUSTOMDLL): custom\custom.cpp
	$(CD) custom
	$(MAKE) -f custom.cpp
	$(CD) ..

clean:
	$(RM) $(OBJFILE)
	$(RM) $(MSIFILE)
	$(CD) custom
	$(MAKE) -f custom.cpp clean
	$(CD) ..

=== debian/changelog ===
krb5 (1.22.1-1) experimental; urgency=medium

  * New upstream version
    - Builds with gcc-15, Closes: #1097099
  * Update symbols files

 -- Sam Hartman <hartmans@debian.org>  Tue, 07 Oct 2025 16:28:29 -0600

krb5 (1.21.3-5) unstable; urgency=medium

  * Non-maintainer upload with maintainer agreement.
  * Fix CVE-2025-24528: Prevent overflow when calculating
    ulog block size (Closes: #1094730)

 -- Bastien Roucariès <rouca@debian.org>  Sun, 23 Feb 2025 17:12:14 +0000

=== debian/control ===
--- 
+++ 
@@ -28,8 +28,7 @@
                     python3-kdcproxy <!nocheck>,
                     python3-pyrad <!nocheck>
 Standards-Version: 4.7.0
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
+Maintainer: Sam Hartman <hartmans@debian.org>
 Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
 Homepage: https://web.mit.edu/kerberos/
 Vcs-Git: https://salsa.debian.org/debian/krb5
@@ -286,3 +285,7 @@
 Architecture: any
 Depends: libkrb5support0 (= ${binary:Version}),
          ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: krb5-doc, krb5-user
+Recommends: krb5-locales
+Multi-Arch: same

=== debian/watch ===
# debian/watch -- Rules for uscan to find new upstream versions.

version=3
#opts=dversionmangle=s/\+dfsg// \
opts=pgpsigurlmangle=s/$/.asc/ http://web.mit.edu/kerberos/dist/ krb5/[\d.]+/krb5-([\d.]+).tar.gz$
